<template>
    <div>
        <v-row v-if="getError.hasError">
            <v-col cols="12">
                <v-alert type="error"
                         dark>
                    {{ getError.errorMessage }}
                </v-alert>
            </v-col>
        </v-row>
        <v-row justify="center">
            <v-col cols="12"
                   md="8"
                   lg="8"
                   class="pb-0 pt-0 pr-0 pl-0 pr-sm-3 pl-sm-3">
                <v-card class="contact-form"
                        max-width="100%">
                    <v-card-title class="darken-1">
                        <span class="white--text">
                            {{ cardTitle }}
                        </span>
                    </v-card-title>
                    <v-form
                        ref="form"
                        v-model="valid"
                        class="px-6 px-md-10 pt-10"
                        lazy-validation>
                        <v-text-field
                            v-model="contact.name"
                            :rules="contact.nameRules"
                            label="Name*"
                            persistent-hint
                            clearable
                            outlined
                            required/>

                        <v-text-field
                            v-model="contact.email"
                            type="email"
                            :rules="contact.emailRules"
                            label="E-mail address*"
                            clearable
                            persistent-hint
                            outlined/>
                        <v-textarea
                            v-model="contact.message"
                            :rules="contact.messageRules"
                            outlined
                            name="input-7-4"
                            label="Message"
                            clearable/>
                    </v-form>
                    <vue-recaptcha ref="recaptcha"
                                   :load-recaptcha-script="true"
                                   :recaptcha-language="captchaLanguage"
                                   class="recaptcha mb-4"
                                   @verify="verifyCaptcha"
                                   @expired="onCaptchaExpired"/>
                    <v-btn class="mb-10"
                           color="#FD1D1D"
                           dark
                           @click="submit">
                        Send Message
                    </v-btn>
                </v-card>
            </v-col>
        </v-row>
    </div>
</template>
<script>
import VueRecaptcha from '../../VueRecaptcha'
import { mapActions, mapGetters } from 'vuex'

export default {
    name: 'ContactCard',
    components: {
        'vue-recaptcha': VueRecaptcha
    },
    data: () => ({
        pageTitle: 'Get in touch with Us',
        cardTitle: 'Got a question? We\'d love to hear from you. Send us a message and we\'ll respond as soon as posible.',
        valid: true,
        contact: {
            name: '',
            nameRules: [
                v => !!v || 'Name is required'
            ],
            email: '',
            emailRules: [
                v => !!v || 'E-mail is required',
                v => /.+@.+/.test(v) || 'E-mail must be valid'
            ],
            message: '',
            messageRules: [
                v => !!v || 'Message is required'
            ],
        }
    }),
    computed: {
        ...mapGetters(['captchaLanguage', 'getCaptchaPassedValue', 'getContactClientInfoError']),
        getError() {
            return this.getContactClientInfoError
        }
    },
    created() {
        this.resetContactState
    },
    methods: {
        ...mapActions(['captchaPassed', 'sendClientInfo', 'sendClientMessage', 'resetContactState']),
        submit () {
            if (this.$refs.form.validate()) {
                this.snackbar = true
                let clientInfo = {
                    name: this.contact.name,
                    email: this.contact.email,
                    phone: this.contact.socialMediaUrl,
                    message: this.contact.message,
                }
                this.sendClientMessage(clientInfo)
            }
        },
        verifyCaptcha: function(response) {
            if (response.length) {
                this.captchaPassed(true);
            } else {
                this.captchaPassed(false);
            }
        },
        onCaptchaExpired: function() {
            this.$refs.recaptcha.reset(); // Direct call reset method
            this.captchaPassed(false);
        }
    }
}
</script>
<style lang="scss" scoped>
    .recaptcha {
        display: flex;
        flex-direction: column;
        align-items: center;
    }
    .v-card__title {
        background-color: #C13584;
    }
    a {
        text-decoration: none;
        color: #000 !important;
    }
</style>
